<?php
namespace T3S\T3sHeaderslider\ViewHelpers;

/*
 * This file is part of the TYPO3 CMS project.
 *
 * It is free software; you can redistribute it and/or modify it under
 * the terms of the GNU General Public License, either version 2
 * of the License, or any later version.
 *
 * For the full copyright and license information, please read the
 * LICENSE.txt file that was distributed with this source code.
 *
 * The TYPO3 project - inspiring people to share!
 */

/**
 * ViewHelper to include a css or js files
 *
 * @package TYPO3
 * @subpackage T3S\T3sHeaderslider\
 */
class IncludeFileViewHelper extends \TYPO3\CMS\Fluid\Core\ViewHelper\AbstractViewHelper {

	/**
	 * Include a CSS/JS files
	 *
	 * @param string $path Path to the CSS/JS file which should be included
	 *
	 * @return void
	 */
	public function render( $path ) {

		$settings = $this->templateVariableContainer->get('settings');

		$path = $GLOBALS['TSFE']->tmpl->getFileName( $path );

		/* @var $pageRenderer \TYPO3\CMS\Core\Page\PageRenderer */
		$pageRenderer = $this->objectManager->get('TYPO3\\CMS\\Core\\Page\\PageRenderer');

		// JS
		if ( strtolower( substr( $path, -3 ) ) === '.js' ) {

			if ($settings['moveJsFromHeaderToFooter']) {

				$pageRenderer->addJsFooterFile( $path );

			} else {

				$pageRenderer->addJsFile( $path );

			}

		// CSS
		} elseif ( strtolower(substr( $path, -4 ) ) === '.css' ) {

			$pageRenderer->addCssFile( $path );

		}
	}
}
