<?php
namespace T3S\T3sHeaderslider\ViewHelpers;

/*
 * This file is part of the TYPO3 CMS project.
 *
 * It is free software; you can redistribute it and/or modify it under
 * the terms of the GNU General Public License, either version 2
 * of the License, or any later version.
 *
 * For the full copyright and license information, please read the
 * LICENSE.txt file that was distributed with this source code.
 *
 * The TYPO3 project - inspiring people to share!
 */

/**
 * ViewHelper to include inlineJs
 *
 * @package TYPO3
 * @subpackage T3S\T3sHeaderslider;
 */
class InlineJsViewHelper extends \TYPO3\CMS\Fluid\Core\ViewHelper\AbstractViewHelper {

	/**
	 * Renders inlineJs
	 *
	 * @return void
	*/
	public function render() {

		$settings = $this->templateVariableContainer->get('settings');

		$name=' JavaScript for t3s_headerslider ';
		$queryNoConflict = $settings['jqueryNoConflict'] ? 'jQuery.noConflict(); jQuery' : 'jQuery';
		$function = '';
		
		switch ( $this->controllerContext->getRequest()->getControllerActionName() ) {
			case 'nivoslider':
				$inWidth = $settings['captionMoveIn']['width'];
				$inHeight = $settings['captionMoveIn']['height'];
				$inFontSize = $settings['captionMoveIn']['fontSize'];
				$inLeft = $settings['captionMoveIn']['left'];
				$inTop = $settings['captionMoveIn']['top'];
				$inDuration = $settings['captionMoveIn']['duration'];
		
				$outWidth = $settings['captionMoveOut']['width'];
				$outHeight = $settings['captionMoveOut']['height'];
				$outFontSize = $settings['captionMoveOut']['fontSize'];
				$outLeft = $settings['captionMoveOut']['left'];
				$outTop = $settings['captionMoveOut']['top'];
				$outDuration = $settings['captionMoveOut']['duration'];
		
				if ( $settings['captions'] == 2 ) {
				$function = '
				function captionMoveIn() {
					jQuery(\'.nivo-caption\')
					.fadeIn(10)
					.animate({width: "'.$inWidth.'",height: "'.$inHeight.'",fontSize:"'.$inFontSize.'",left: "'.$inLeft.'",top:"'.$inTop.'"},'.$inDuration.')
				;};
		
				function captionMoveOut() {
					jQuery(\'.nivo-caption\')
					.fadeOut(500)
					.animate({width: "'.$outWidth.'",height: "'.$outHeight.'",fontSize:"'.$outFontSize.'",left: "'.$outLeft.'",top:"'.$outTop.'"},'.$outDuration.')
				;};
		
				function bulletsIntro() {
					jQuery(\'.nivo-controlNav a\')
					.animate({marginRight: "-62px"},500)
					.animate({marginRight: "4px"},1000)
				;};
	
				';
				}
			
				// script-options
				$options  = $settings['controlNav'] ? '' : 'controlNav:false,';
				$options .= $settings['manualAdvance'] ? 'manualAdvance:true,' : '';
				$options .= $settings['effect'] == 'random' ? '' : 'effect:\''.$settings['effect'].'\',';
				$options .= $settings['slices'] == 15 ? '' : 'slices:'.$settings['slices'].',';
				$options .= $settings['boxCols'] == 8 ? '' : 'boxCols:'.$settings['boxCols'].',';
				$options .= $settings['boxRows'] == 4 ? '' : 'boxRows:'.$settings['boxRows'].',';
				$options .= $settings['animSpeed'] == 500 ? '' : 'animSpeed:'.$settings['animSpeed'].',';
				$options .= $settings['pauseTime'] == 3000 ? '' : 'pauseTime:'.$settings['pauseTime'].',';
				$options .= $settings['randomStart'] ? 'startSlide:'.$settings['startSlide'].',' : '';
				$options .= $settings['pauseOnHover'] ? '' : 'pauseOnHover:false,';
				$options .= $settings['randomStart'] ? 'randomStart:true,' : '';
				$options .= $settings['prevText'] == 'Prev' ? '' : 'prevText:\''.$settings['prevText'].'\',';
				$options .= $settings['nextText'] == 'Next' ? '' : 'nextText:\''.$settings['nextText'].'\',';
				$options .= $settings['directionNav'] ? 'directionNav:true,' : 'directionNav:false,';
		
				if ( $settings['captions'] == 2 ) {
					$options .= ' afterLoad: function (){captionMoveIn();bulletsIntro();
						$(\'.slider-wrapper\').css(\'background\', \'none\');
						$(\'#t3s-headerslider\').css(\'min-height\', \'1px\');},';
					$options .= ' beforeChange: function (){captionMoveOut();captionMoveIn();},';
				} else {
					$options .= ' afterLoad: function (){$(\'.slider-wrapper\').css(\'background\', \'none\');},';
				}

				$inlineJS =  $queryNoConflict.'(function(){
					var imgWidth = $(\'#t3s-headerslider img\').width(),
						imgHeight = $(\'#t3s-headerslider img\').height(),
						sliderWidth = $(\'#t3s-headerslider\').width(),
						sliderHeight = Math.round(imgHeight / imgWidth * sliderWidth);
					$(\'#t3s-headerslider\').css(\'min-height\', sliderHeight+\'px\');
					$(\'#t3s-headerslider img\').removeAttr(\'width\').removeAttr(\'height\');});';
				$inlineJS .=  $queryNoConflict.' (window).load(function(){jQuery(\'#t3s-headerslider\').nivoSlider({'.$options.'});});';				
			break;
			case 'customslider':
			
				$inlineJS = $settings['customslider']['inlineJs'];

			break;
	
		}

		/* @var $pageRenderer \TYPO3\CMS\Core\Page\PageRenderer */
		$pageRenderer = $this->objectManager->get('TYPO3\\CMS\\Core\\Page\\PageRenderer');
		
		if ($settings['moveJsFromHeaderToFooter'] ) {
			$pageRenderer->addJsFooterInlineCode($name,$function.$inlineJS);
		} else {
			$pageRenderer->addJsInlineCode($name,$function.$inlineJS);
		}

	}

}
